package net.knarcraft.minecraftserverlauncher.server.servertypes;

import net.knarcraft.minecraftserverlauncher.server.ServerVersionContainer;

/**
 * This class represents the Travertine proxy server type
 */
public class Travertine extends Waterfall {

    /**
     * Instantiates a new Travertine server type
     *
     * @param typeName    <p>The name of the server type</p>
     * @param isProxy     <p>Whether this server type is a proxy server</p>
     * @param versions    <p>The available versions for the server type</p>
     * @param versionURL  <p>The URL used to finding the newest version</p>
     * @param srcStart    <p>The string after which the version id starts</p>
     * @param srcEnd      <p>The string marking the end of the version id</p>
     * @param downloadURL <p>The URL used for downloading the latest version</p>
     */
    public Travertine(String typeName, boolean isProxy, String[] versions, String versionURL, String srcStart,
                      String srcEnd, String downloadURL) {
        super(typeName, isProxy, versions, versionURL, srcStart, srcEnd, downloadURL);
        this.oldVersion = ServerVersionContainer.getInstance().getTravertineVersion();
        this.versionUpdateFunction = serverVersionContainer::setTravertineVersion;
    }

}
