package net.knarcraft.minecraftserverlauncher.server;

import net.knarcraft.minecraftserverlauncher.Main;
import net.knarcraft.minecraftserverlauncher.utility.CommonFunctions;
import org.junit.Before;
import org.junit.Test;

import java.io.*;

import static junit.framework.TestCase.assertEquals;
import static net.knarcraft.minecraftserverlauncher.utility.CommonFunctions.createAllFolders;

public class ServerVersionContainerTest {

    private final String filesDirectory = Main.getApplicationWorkDirectory() + File.separator + "files";
    private final String versionFile = filesDirectory + File.separator + "versions.csv";
    private ServerVersionContainer serverVersionContainer;

    @Before
    public void setUp() {
        try {
            createAllFolders();
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        }
        serverVersionContainer = ServerVersionContainer.getInstance();
    }

    @Test
    public void toStringTest() {
        serverVersionContainer.reset();
        assertEquals("vanillaVersion;null\nsnapshotVersion;null\nbungeeVersion;null\nwaterfallVersion;null\n" +
                        "travertineVersion;null\nspongeVanillaVersions;",
                serverVersionContainer.toString());
    }

    @Test
    public void saveStateTest() throws IOException {
        serverVersionContainer.saveState();
        BufferedReader reader = new BufferedReader(new InputStreamReader(new FileInputStream(versionFile)));
        String savedData = CommonFunctions.readBufferedReader(reader);
        assertEquals(serverVersionContainer.toString(), savedData);
    }

}
